<?php

/**
 *  Sandbox Authorize
    dediteam69 / Ded1@gency

    API LOGIN ID : 2PnJWh4S9D6k
    TRANSACTION KEY : 5H49H8PB8rB68wyc
    SECRET KEY : Simon
 */

namespace Bydedi\Payment;

use Tpe;
use Commande;
use Panier;
use net\authorize\api\contract\v1 as AnetAPI;
use net\authorize\api\controller as AnetController;
use net\authorize\api\constants\ANetEnvironment;

/**
 * Class AuthorizeDirect
 * @package Shopbydedi\Payment
 */
class AuthorizeDirect
{
    /**
     * @var AnetAPI\MerchantAuthenticationType
     */
    protected $merchantAuthentication;

    /**
     * @var string
     */
    protected $mode;

    public function __construct($config)
    {
        if ($config['authorize']['mode'] != 'prod') {
            $config['authorize']['name'] = '2PnJWh4S9D6k';
            $config['authorize']['transaction_key'] = '5H49H8PB8rB68wyc';
        }

        $this->merchantAuthentication = new AnetAPI\MerchantAuthenticationType();
        $this->merchantAuthentication->setName($config['authorize']['name']);
        $this->merchantAuthentication->setTransactionKey($config['authorize']['transaction_key']);

        $this->mode = ($config['authorize']['mode'] == 'prod') ? ANetEnvironment::PRODUCTION : ANetEnvironment::SANDBOX;

    }

    /**
     * @param Tpe $tpe
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     *
     * @return mixed
     */
    public function doAuthorization(Tpe $tpe, $amount, $cardNumber, $cardExpirationDate, $cardCrypto)
    {
        // TODO: Implement doAuthorization() method.
    }

    /**
     * @param Tpe $tpe
     * @param $amount
     * @param $cardNumber
     * @param $cardExpirationDate
     * @param $cardCrypto
     *
     * @return mixed
     */
    public function doDebit(Tpe $tpe, $amount, $cardNumber, $cardExpirationDate, $cardCrypto)
    {
        $creditCard = new AnetAPI\CreditCardType();
        $creditCard->setCardNumber($cardNumber);                    // "4111111111111111"
        $creditCard->setExpirationDate($cardExpirationDate);        // "2038-12"
        $paymentOne = new AnetAPI\PaymentType();
        $paymentOne->setCreditCard($creditCard);

        // Create a transaction
        $transactionRequestType = new AnetAPI\TransactionRequestType();
        $transactionRequestType->setTransactionType("authCaptureTransaction");
        $transactionRequestType->setAmount($amount);
        $transactionRequestType->setPayment($paymentOne);

        $request = new AnetAPI\CreateTransactionRequest();
        $request->setMerchantAuthentication($this->merchantAuthentication);
        $request->setTransactionRequest($transactionRequestType);
        $controller = new AnetController\CreateTransactionController($request);

        /** @var \net\authorize\api\contract\v1\CreateTransactionResponse $responseAuthorize */
        $responseAuthorize = $controller->executeWithApiResponse($this->mode);

        $response['authorize'] = $responseAuthorize;
        $response['order_id'] = $tpe->tpe_reference_id;

        return $this->response($response);

    }

    /**
     * @param array $request
     *
     * @return mixed
     */
    public function response($request)
    {
        $return = ['status' => false];

        if (!empty($request['order_id'])) {
            $tpe = new Tpe;

            if ($request['authorize'] != null) {
                /** @var \net\authorize\api\contract\v1\TransactionResponseType $tresponse */
                $tresponse = $request['authorize']->getTransactionResponse();

                $messages = $tresponse->getMessages();
                $request['messages'] = '';

                // cas response ok
                if (($tresponse != null) && ($tresponse->getResponseCode() == "1")) {

                    $commande = new Commande();
                    try {
                        $return['commande_id'] = $commande->saveFromPanier(Panier::getInstance());
                        $tpe->assoc($request['order_id'], $return['commande_id']);
                    } catch (\Exception $e) {
                        $return['status'] = false;
                        $return['tpe_reference_id'] = $request['order_id'];
                        return $return;
                    }

                    foreach ($messages as $message) {
                        $request['messages'] .= sprintf('%s - %s', $message->getCode(), $message->getDescription());
                    }

                    $return['status'] = true;
                    $return['tpe_reference_id'] = $request['order_id'];
                } else {
                    $request['error'] = "Charge Credit Card ERROR :  Invalid response";
                    $request['error_plus'] = '';

                    $errors = $tresponse->getErrors();

                    foreach ($messages as $message) {
                        $request['messages'] .= sprintf('%s - %s', $message->getCode(), $message->getText());
                    }

                    foreach ($errors as $error) {
                        $request['error_plus'] .= sprintf('%s - %s', $error->getErrorCode(), $error->getErrorText());
                    }

                    $return = array_merge($request, $request);
                }
            } else {
                $request['error'] = "Charge Credit card Null response returned";

                $return = array_merge($request, $request);
            }

            unset($request['authorize']);
            $tpe->addResponse($request['order_id'], $request);
        }

        return $return;
    }

    /**
     * @param $params
     * @return mixed
     */
    public function sendRequest($params)
    {
        // TODO: Implement sendRequest() method.
    }
}
